<!DOCTYPE html>









































<html class=" is-full hasPageActions  has-default-focus theme-light" lang="en-us" dir="ltr" data-css-variable-support="true" data-authenticated="false" data-auth-status-determined="false" data-target="docs" x-ms-format-detection="none">

<head>
	<meta charset="utf-8" />
	<meta name="viewport" content="width=device-width, initial-scale=1.0" />
	<meta property="og:title" content="Visual Studio product family documentation" />
	<meta property="og:type" content="website" />
	<meta property="og:url" content="https://docs.microsoft.com/en-us/visualstudio/" />
			<meta property="og:description" content="Explore documentation for the Visual Studio family of products." />
		<meta property="og:image" content="https://docs.microsoft.com/en-us/media/logos/logo-ms-social.png" />
		<meta property="og:image:alt" content="Microsoft Logo" />

	<meta name="twitter:card" content="summary" />
	<meta name="twitter:site" content="@docsmsft" />


	<meta name="summary" content="Explore documentation for the Visual Studio family of products." />
<meta name="description" content="Explore documentation for the Visual Studio family of products." />
<meta name="ms.topic" content="hub-page" />
<meta name="ms.date" content="11/13/2019" />
<meta name="ms.author" content="ghogen" />
<meta name="author" content="ghogen" />
<meta name="ms.manager" content="jillfra" />
<meta name="toc_preview" content="true" />
<meta name="audience" content="developer" />
<meta name="manager" content="jillfra" />
<meta name="breadcrumb_path" content="/visualstudio/_breadcrumb/toc.json" />
<meta name="ms.prod" content="visual-studio-windows" />
<meta name="uhfHeaderId" content="MSDocsHeader-VisualStudio" />
<meta name="search.ms_sitename" content="Docs" />
<meta name="search.ms_docsetname" content="docs" />
<meta name="locale" content="en-us" />
<meta name="site_name" content="Docs" />
<meta name="search.ms_product" content="VS" />
<meta name="depot_name" content="VS.docs" />
<meta name="updated_at" content="2020-04-02 11:03 PM" />
<meta name="document_id" content="23778818-b46e-a741-75c1-a32feee82694" />
<meta name="document_version_independent_id" content="d8902645-87e4-2338-6cfc-9151294173b8" />
<meta name="monikers" content="vs-2017" />
<meta name="monikers" content="vs-2019" />
<meta name="original_ref_skeleton_git_url" content="https://github.com/MicrosoftDocs/visualstudio-docs-pr/blob/live/docs/index.yml" />
<meta name="ref_skeleton_gitcommit" content="https://github.com/MicrosoftDocs/visualstudio-docs-pr/blob/022a28a4964ad7bac4d19f764a939ad86d4b9a7e/docs/index.yml" />
<meta name="page_type" content="hub" />


<link href="https://docs.microsoft.com/en-us/visualstudio/" rel="canonical">
	<title>Visual Studio product family documentation | Microsoft Docs</title>

		<link rel="stylesheet" href="/_themes/docs.theme/master/en-us/_themes/styles/d8be7e4d.site-ltr.css ">

	<link rel="stylesheet" href="/_themes/docs.theme/master/en-us/_themes/styles/6b33afea.hub.css ">


	<script>
	var msDocs = {
		data: {
			timeOrigin: Date.now(),
			azureHeaderLocale: 'en-us',
			contentLocale: 'en-us',
			contentDir: 'ltr',
			userLocale: 'en-us',
			userDir: 'ltr',
			pageTemplate: 'Hub',
			brand: 'visual-studio',
			context: {

			},
			hasBinaryRating: false,
			hasGithubIssues: false,
			showFeedbackReport: false,
			enableTutorialFeedback: false,
			feedbackSystem: 'GitHub',
			feedbackGitHubRepo: 'MicrosoftDocs/visualstudio-docs',
			feedbackProductUrl: 'https://developercommunity.visualstudio.com/',
			contentGitUrl: '',
			defaultDevLang: 'csharp',
			extendBreadcrumb: false,
			isEditDisplayable: false,
			hideViewSource: false
		},
		functions:{}
	};
	if (!('Promise' in window && 'resolve' in window.Promise && 'reject' in window.Promise && 'all' in window.Promise && 'race' in window.Promise)) {
		document.write('<script src="https://static.docs.com/ui/third-party/bluebird/3.5.0/bluebird.min.js" integrity="sha384-aD4BDeDGeLXLpPK4yKeqtZQa9dv4a/7mQ+4L5vwshIYH1Mc2BrXvHd32iHzYCQy5" crossorigin="anonymous"><\/script>');
	}
	if (typeof fetch !== 'function') {
		document.write('<script src="https://static.docs.com/ui/third-party/fetch/3.0.0/fetch.umd.min.js" integrity="sha384-EQIXrC5K2+7X8nGgLkB995I0/6jfAvvyG1ieZ+WYGxgJHFMD/alsG9fSDWvzb5Y1" crossorigin="anonymous"><\/script>');
	}
	if (typeof HTMLTemplateElement === 'undefined') {
		document.write('<script src="https://static.docs.com/ui/third-party/template/1.4.0/template.min.js" integrity="sha384-1zKzI6ldTVHMU7n0W2HpE/lhHI+UG4D9IIaxbj3kT2UhCWicdTuJkTtnKuu0CQzN" crossorigin="anonymous"><\/script>');
	}
	if (typeof URL !== 'function') {
		document.write('<script src="https://static.docs.com/ui/third-party/url/0.5.7/url.min.js" integrity="sha384-vn7xBMtpSTfzaTRWxj0kVq0UcsbBrTOgZ/M1ISHqe1V358elYva+lfiEC+T8jLPc" crossorigin="anonymous"><\/script>');
	}
	</script>

	<script src="https://ajax.aspnetcdn.com/ajax/jQuery/jquery-3.3.1.min.js" integrity="sha384-tsQFqpEReu7ZLhBV2VZlAu7zcOV+rXbYlF2cqB8txI/8aZajjp4Bqd+V6D5IgvKT" crossorigin="anonymous"></script>
		<script src="/_themes/docs.theme/master/en-us/_themes/scripts/3ac88538.index-docs.js"></script>

</head>

<body lang="en-us" dir="ltr">
<div class="header-holder has-default-focus">
	<a href="#main" class="skip-to-main-link visually-hidden-until-focused is-fixed has-inner-focus focus-visible has-top-zero has-left-zero has-right-zero has-padding-medium has-text-centered has-body-background-medium" tabindex="1">Skip to main content</a>
		<div id="headerAreaHolder" data-bi-name="header">
<header role="banner" itemscope="itemscope" itemtype="http://schema.org/Organization">
	<div class="nav-bar">
		<a itemprop="url" href="https://www.microsoft.com" aria-label="Microsoft" class="nav-bar-button has-padding-left-medium-mobile">
			<div class="nav-bar-logo has-background-image theme-display is-light" role="presentation" aria-hidden="true" itemprop="logo" itemscope="itemscope"></div>
			<div class="nav-bar-logo has-background-image theme-display is-dark is-high-contrast" role="presentation" aria-hidden="true" itemprop="logo" itemscope="itemscope"></div>
		</a>
		<div class="nav-bar-item is-hidden-tablet">
			<button class="nav-bar-button is-size-5 is-text has-body-background has-padding-none" title="Global navigation">
				<span class="has-text-weight-semibold has-padding-left-small has-padding-bottom-extra-small"></span>
				<div class="nav-bar-burger experimental_header has-padding-none has-height-zero">
					<span></span>
					<span></span>
					<span></span>
					<span class="is-visually-hidden">Global navigation</span>
				</div>
			</button>
		</div>
		<nav class="nav-bar-nav" role="navigation" aria-label="Global">
			<ul class="nav-bar-nav-list">
				<li class="nav-bar-item is-category has-spacing">
					<a class="nav-bar-button title has-hover-underline is-4" itemprop="url" href="/en-us/">
						<span>Docs</span>
					</a>
				</li>
				<li class="nav-bar-item">
					<a class="nav-bar-button has-hover-underline" href="/en-us/">
						<span>Documentation</span>
					</a>
				</li>
				<li class="nav-bar-item">
					<a class="nav-bar-button has-hover-underline" href="/en-us/learn/">
						<span>Learn</span>
					</a>
				</li>
				<li class="nav-bar-item">
					<a class="nav-bar-button has-hover-underline" href="/answers/">
						<span>Q&A</span>
					</a>
				</li>
				<li class="nav-bar-item">
					<a class="nav-bar-button has-hover-underline" href="/en-us/samples/browse/">
						<span>Code Samples</span>
					</a>
				</li>
				<li class="dropdown nav-bar-item" hidden="">
					<button aria-expanded="false" class="dropdown-trigger nav-bar-button has-hover-underline" aria-controls="ax-53">
						<span>More</span>
						<span class="nav-bar-button-chevron" aria-hidden="true">
							<span class="docon docon-chevron-down-light expanded-indicator"></span>
						</span>
					</button>
					<ul class="dropdown-menu" id="ax-53" aria-label="More">
						<li class="nav-bar-item" hidden="">
							<a class="nav-bar-button" href="/en-us/">Documentation</a>
						</li>
						<li class="nav-bar-item" hidden="">
							<a class="nav-bar-button" href="/en-us/learn/">Learn</a>
						</li>
						<li class="nav-bar-item" hidden="">
							<a class="nav-bar-button" href="/answers/">Q&A</a>
						</li>
						<li class="nav-bar-item" hidden="">
							<a class="nav-bar-button" href="/en-us/samples/browse/">Code Samples</a>
						</li>
					</ul>
				</li>
			</ul>
		</nav>
		<span class="nav-bar-spacer is-hidden-mobile"></span>
		<div class="nav-bar-item has-flex-grow-mobile has-flex-shrink-mobile">
		</div>
		<div class="nav-bar-item is-size-7 is-hidden-mobile">
			<a class="docs-sign-in auth-status-determined not-authenticated button is-text has-inner-focus has-text-primary is-small" href="#">
				Sign in
			</a>
			<div class="dropdown has-caret auth-status-determined authenticated">
				<button class="dropdown-trigger button is-text has-padding-none has-background-transparent" aria-controls="user-menu" aria-expanded="false" aria-label="Your Account">
					<figure class="image is-36x36">
						<img class="has-body-background-medium is-rounded" data-profile-property="avatarUrl">
					</figure>
				</button>
				<div class="dropdown-menu box" id="user-menu" role="menu">
				</div>
			</div>
		</div>
	</div>
	<div class="nav-bar is-content is-hidden-mobile has-border-top">
	</div>
</header>		</div>
		<div class="content-header uhf-container has-padding has-default-focus has-border-bottom-none" data-bi-name="content-header">
		<div class="content-header-controls">
			<button type="button" class="contents-button button" data-bi-name="contents-expand" aria-haspopup="true">
				<span class="icon"><span class="docon docon-menu" aria-hidden="true"></span></span>
				<span>Contents</span>
			</button>
		</div>
		<div class="content-header-controls exit-focus">
			<button type="button" class="ap-collapse-behavior ap-expanded button" data-bi-name="ap-collapse" aria-controls="action-panel">
				<span class="icon"><span class="docon docon-exit-mode" aria-hidden="true"></span></span>
				<span>Exit focus mode</span>
			</button>
		</div>
		<div class="has-padding-none-tablet has-padding-medium is-size-7 is-flex-touch has-flex-justify-content-space-between-touch has-flex-grow">
			<ul class="is-hidden-mobile action-list has-flex-justify-content-start has-flex-justify-content-end-tablet is-flex is-flex-row has-flex-wrap has-flex-grow is-unstyled">
				<li>
					<button type="button" class="bookmark button is-text has-inner-focus is-small is-icon-only-touch" data-list-type="bookmarks" data-bi-name="bookmark" title="Bookmark this page">
						<span class="icon" aria-hidden="true">
							<span class="docon docon-single-bookmark"></span>
						</span>
						<span class="bookmark-status is-visually-hidden-touch is-hidden-portrait">Bookmark</span>
					</button>
				</li>
				<li>
<div class="sharing dropdown has-caret">
	<button class="dropdown-trigger button is-text is-fullwidth has-flex-justify-content-start has-inner-focus is-small is-icon-only-touch" aria-controls="sharing-menu" aria-expanded="false" title="Share This Document" data-bi-name="share">
		<span class="icon" aria-hidden="true">
			<span class="docon docon-sharing"></span>
		</span>
		<span class="is-visually-hidden-touch is-hidden-portrait">Share</span>
	</button>
	<div class="dropdown-menu has-padding-small" id="sharing-menu">
		<ul data-bi-name="share-links">
			<li>
				<a class="button is-text is-fullwidth has-flex-justify-content-start has-inner-focus is-small share-twitter" data-bi-name="twitter">
					<span class="icon">
						<span class="docon docon-brand-twitter has-text-primary" aria-hidden="true"></span>
					</span>
					<span>Twitter</span>
				</a>
			</li>
			<li>
				<a class="button is-text is-fullwidth has-flex-justify-content-start has-inner-focus is-small share-linkedin" data-bi-name="linkedin">
					<span class="icon">
						<span class="docon docon-brand-linkedin has-text-primary" aria-hidden="true"></span>
					</span>
					<span>LinkedIn</span>
				</a>
			</li>
			<li>
				<a class="button is-text is-fullwidth has-flex-justify-content-start has-inner-focus is-small share-facebook" data-bi-name="facebook">
					<span class="icon">
						<span class="docon docon-brand-facebook has-text-primary" aria-hidden="true"></span>
					</span>
					<span>Facebook</span>
				</a>
			</li>
			<li>
				<a class="button is-text is-fullwidth has-flex-justify-content-start has-inner-focus is-small share-email" data-bi-name="email">
					<span class="icon">
						<span class="docon docon-mail-message-fill has-text-primary" aria-hidden="true"></span>
					</span>
					<span>Email</span>
				</a>
			</li>
		</ul>
	</div>
</div>				</li>
			</ul>
			<button type="button" class="has-border contents-button button is-small is-text is-hidden-tablet has-inner-focus" aria-label="Contents" data-bi-name="contents-expand">
				<span class="icon">
					<span class="docon docon-editor-list-bullet" aria-hidden="true"></span>
				</span>
				<span>Table of contents</span>
			</button>
			<div class="is-invisible"></div>
			<div class="is-hidden-tablet level-item is-flexible level-right">
				<button type="button" class="page-actions-button button is-small is-text is-hidden-tablet has-inner-focus has-border is-full-height  has-margin-left-small" aria-label="Page Actions" data-bi-name="pageactions">
					<span aria-hidden="true">. . .</span>
				</button>
			</div>
		</div>
	</div>

	<div id="banner-holder" class="has-default-focus has-overflow-hidden">
	</div>

	<div id="disclaimer-holder" class="has-overflow-hidden has-default-focus"></div>
	</div>

	<div class="mainContainer  uhf-container is-full  has-default-focus" data-bi-name="body">

		<div class="columns has-large-gaps is-gapless-mobile  is-gapless">


			<section class="primary-holder column ">
				<div class="columns is-gapless-mobile has-large-gaps  is-gapless">


				<div id="main-column" class="column ">

					<main id="main" role="main" class="content " data-bi-name="content" lang="en-us" dir="ltr">



						


						<!-- <content> -->
							<section id="hero" class="hero has-background-visual-studio">
	<div class="uhf-container has-text-visual-studio-invert">
		<div class="columns">
			<div class="column is-10-desktop">
				<div class="has-padding-top-extra-large has-padding-bottom-extra-large">
					<h1 id="hero-title" class="title">Visual Studio product family documentation</h1>
						<p id="hero-summary" class="has-margin-none has-padding-top-medium">Explore documentation for the Visual Studio family of products.</p>
				</div>
			</div>
		</div>
	</div>
</section>


	<section id="product-directory" class="has-background-alternating-grey">
		<div class="uhf-container has-padding-top-extra-large has-padding-bottom-extra-large">
			<div class="columns">
				<div class="column">
					<div id="product-cards" class="columns is-multiline " data-bi-name="hub-product-card">
							<div class="column is-4-tablet is-4-desktop item-column" data-categories="">				
									<div class="box has-margin-none is-full-height has-padding-large">
											<img src="media/vs-ide-2019.svg?view=vs-2019" alt="" loading="lazy" width="48" height="48" class="image is-48x48 has-margin-bottom-small" data-linktype="relative-path">
										<h3 id="visual-studio-0" class="is-size-4 has-margin-none">Visual Studio</h3>
										<ul class="has-line-height-reset has-margin-left-none has-margin-bottom-none has-margin-top-extra-small">
												<li class="is-unstyled has-margin-bottom-small">
													<a href="/en-us/visualstudio/windows?view=vs-2019" class="is-block is-size-7" data-linktype="absolute-path">
														Visual Studio 2019 (current)
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="/en-us/visualstudio/windows?view=vs-2017" class="is-block is-size-7" data-linktype="absolute-path">
														Visual Studio 2017
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://docs.microsoft.com/previous-versions/visualstudio/" class="is-block is-size-7" data-linktype="external">
														Previous versions
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://docs.microsoft.com/visualstudio/releases/2019/release-notes" class="is-block is-size-7" data-linktype="external">
														Release notes
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://visualstudio.microsoft.com/" class="is-block is-size-7" data-linktype="external">
														Product page
													</a>
												</li>
										</ul>
									</div>
							</div>
							<div class="column is-4-tablet is-4-desktop item-column" data-categories="">				
									<div class="box has-margin-none is-full-height has-padding-large">
											<img src="media/vs-mac-2019.svg?view=vs-2019" alt="" loading="lazy" width="48" height="48" class="image is-48x48 has-margin-bottom-small" data-linktype="relative-path">
										<h3 id="visual-studio-for-mac-1" class="is-size-4 has-margin-none">Visual Studio for Mac</h3>
										<ul class="has-line-height-reset has-margin-left-none has-margin-bottom-none has-margin-top-extra-small">
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://docs.microsoft.com/visualstudio/mac" class="is-block is-size-7" data-linktype="external">
														Visual Studio 2019 for Mac (current)
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://docs.microsoft.com/visualstudio/mac/?view=vsmac-2017" class="is-block is-size-7" data-linktype="external">
														Visual Studio 2017 for Mac
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://docs.microsoft.com/visualstudio/releasenotes/vs2019-mac-relnotes" class="is-block is-size-7" data-linktype="external">
														Release notes
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://visualstudio.microsoft.com/vs/mac/" class="is-block is-size-7" data-linktype="external">
														Product page
													</a>
												</li>
										</ul>
									</div>
							</div>
							<div class="column is-4-tablet is-4-desktop item-column" data-categories="">				
									<div class="box has-margin-none is-full-height has-padding-large">
											<img src="media/vs-code-logo.svg?view=vs-2019" alt="" loading="lazy" width="48" height="48" class="image is-48x48 has-margin-bottom-small" data-linktype="relative-path">
										<h3 id="visual-studio-code-2" class="is-size-4 has-margin-none">Visual Studio Code</h3>
										<ul class="has-line-height-reset has-margin-left-none has-margin-bottom-none has-margin-top-extra-small">
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://code.visualstudio.com/docs" class="is-block is-size-7" data-linktype="external">
														Documentation
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://code.visualstudio.com/updates" class="is-block is-size-7" data-linktype="external">
														Release notes
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://code.visualstudio.com" class="is-block is-size-7" data-linktype="external">
														Product page
													</a>
												</li>
										</ul>
									</div>
							</div>
							<div class="column is-4-tablet is-4-desktop item-column" data-categories="">				
									<div class="box has-margin-none is-full-height has-padding-large">
											<img src="media/vs-ide-2019.svg?view=vs-2019" alt="" loading="lazy" width="48" height="48" class="image is-48x48 has-margin-bottom-small" data-linktype="relative-path">
										<h3 id="visual-studio-online-3" class="is-size-4 has-margin-none">Visual Studio Online</h3>
										<ul class="has-line-height-reset has-margin-left-none has-margin-bottom-none has-margin-top-extra-small">
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://docs.microsoft.com/visualstudio/online/" class="is-block is-size-7" data-linktype="external">
														Documentation
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://code.visualstudio.com/docs/remote/vsonline" class="is-block is-size-7" data-linktype="external">
														Use with Visual Studio Code
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://visualstudio.microsoft.com/services/visual-studio-online/" class="is-block is-size-7" data-linktype="external">
														Product page
													</a>
												</li>
										</ul>
									</div>
							</div>
							<div class="column is-4-tablet is-4-desktop item-column" data-categories="">				
									<div class="box has-margin-none is-full-height has-padding-large">
											<img src="media/vs-mobile-center.svg?view=vs-2019" alt="" loading="lazy" width="48" height="48" class="image is-48x48 has-margin-bottom-small" data-linktype="relative-path">
										<h3 id="visual-studio-app-center-4" class="is-size-4 has-margin-none">Visual Studio App Center</h3>
										<ul class="has-line-height-reset has-margin-left-none has-margin-bottom-none has-margin-top-extra-small">
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://docs.microsoft.com/appcenter" class="is-block is-size-7" data-linktype="external">
														Documentation
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://visualstudio.microsoft.com/app-center/" class="is-block is-size-7" data-linktype="external">
														Portal
													</a>
												</li>
										</ul>
									</div>
							</div>
							<div class="column is-4-tablet is-4-desktop item-column" data-categories="">				
									<div class="box has-margin-none is-full-height has-padding-large">
											<img src="media/vs-subscription-temp.svg?view=vs-2019" alt="" loading="lazy" width="48" height="48" class="image is-48x48 has-margin-bottom-small" data-linktype="relative-path">
										<h3 id="visual-studio-subscriptions-5" class="is-size-4 has-margin-none">Visual Studio Subscriptions</h3>
										<ul class="has-line-height-reset has-margin-left-none has-margin-bottom-none has-margin-top-extra-small">
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://docs.microsoft.com/visualstudio/subscriptions" class="is-block is-size-7" data-linktype="external">
														Documentation
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://visualstudio.microsoft.com/subscriptions" class="is-block is-size-7" data-linktype="external">
														Info on visualstudio.com
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://my.visualstudio.com" class="is-block is-size-7" data-linktype="external">
														Portal
													</a>
												</li>
												<li class="is-unstyled has-margin-bottom-small">
													<a href="https://manage.visualstudio.com" class="is-block is-size-7" data-linktype="external">
														Administration
													</a>
												</li>
										</ul>
									</div>
							</div>
					</div>
				</div>
			</div>
		</div>
	</section>




						<!-- </content> -->

						</main>

						<!-- recommended content page section -->


						<!-- end recommended content page section -->

						<!-- page rating section -->
						<!-- end page rating section -->


						<!-- feedback section -->

						<!-- end feedback section -->

						<!-- feedback report section -->
						<!-- end feedback report section -->

						<div class="footerContainer is-visible-interactive has-default-focus  has-border-top has-margin-none">
<footer id="footer-interactive" data-bi-name="footer" class="footer-layout">

    <a data-mscc-ic="false" class="locale-selector-link" href="#" data-bi-name="select-locale"><span class="icon docon docon-world is-size-4 has-margin-right-small" aria-hidden="true"></span><span class="local-selector-link-text has-inner-focus"></span></a>

    <ul class="links" data-bi-name="footerlinks">
		<li><a data-mscc-ic="false" href="https://docs.microsoft.com/previous-versions/" data-bi-name="archivelink">Previous Version Docs</a></li>
		<li><a data-mscc-ic="false" href="https://docs.microsoft.com/teamblog" data-bi-name="bloglink">Blog</a></li>
		<li><a data-mscc-ic="false" href="https://docs.microsoft.com/contribute" data-bi-name="contributorGuide">Contribute</a></li>
			<li><a data-mscc-ic="false" href="https://go.microsoft.com/fwlink/?LinkId=521839" data-bi-name="privacy">Privacy &amp; Cookies</a></li>
		<li><a data-mscc-ic="false" href="/en-us/legal/termsofuse" data-bi-name="termsofuse">Terms of Use</a></li>
		<li><a data-mscc-ic="false" href="https://aka.ms/sitefeedback" data-bi-name="feedback">Site Feedback</a></li>
		<li><a data-mscc-ic="false" href="https://www.microsoft.com/en-us/legal/intellectualproperty/Trademarks/EN-US.aspx" data-bi-name="trademarks">Trademarks</a></li>
		<li>&copy; Microsoft 2020</li>
    </ul>
</footer>
						</div>
					</div>


					<!--end of div.columns -->
				</div>

			<!--end of .primary-holder -->
			</section>

			<aside id="interactive-container" class="interactive-container is-visible-interactive column has-body-background-dark ">
			</aside>
		</div>

		<!--end of .mainContainer -->
	</div>

	<div id="openFeedbackContainer" class="openfeedback-container"></div>

	<div class="footerContainer has-default-focus is-hidden-interactive  has-border-top has-margin-none">
<footer id="footer" data-bi-name="footer" class="footer-layout uhf-container has-padding" role="contentinfo">

    <div class="is-flex is-full-height has-padding-right-extra-large-desktop">
		<a data-mscc-ic="false" class="locale-selector-link has-flex-shrink-none" href="#" data-bi-name="select-locale"><span class="icon docon docon-world is-size-4 has-margin-right-small" aria-hidden="true"></span><span class="local-selector-link-text"></span></a>
		<div class="has-margin-left-medium has-margin-right-medium has-flex-shrink-none">
<div class="dropdown has-caret-up">
	<button class="dropdown-trigger button is-text is-small is-icon-only-touch has-inner-focus theme-dropdown-trigger"
		aria-controls="theme-menu" aria-expanded="false" title="Theme" data-bi-name="theme">
		<span class="icon">
			<span class="docon docon-sun" aria-hidden="true"></span>
		</span>
		<span>Theme</span>
	</button>
	<div class="dropdown-menu" id="theme-menu" role="menu">
		<ul class="theme-selector has-padding-small">
			<li class="theme is-block">
				<button class="button is-text is-small theme-control is-fullwidth has-flex-justify-content-start"
					data-theme-to="light">
					<span class="theme-light has-margin-right-small">
						<span
							class="theme-selector-icon css-variable-support has-border is-inline-block has-body-background"
							aria-hidden="true">
							<svg class="svg" xmlns="http://www.w3.org/2000/svg"
								viewBox="0 0 22 14">
								<rect width="22" height="14" class="has-fill-body-background" />
								<rect x="5" y="5" width="12" height="4" class="has-fill-secondary" />
								<rect x="5" y="2" width="2" height="1" class="has-fill-secondary" />
								<rect x="8" y="2" width="2" height="1" class="has-fill-secondary" />
								<rect x="11" y="2" width="3" height="1" class="has-fill-secondary" />
								<rect x="1" y="1" width="2" height="2" class="has-fill-secondary" />
								<rect x="5" y="10" width="7" height="2" rx="0.3" class="has-fill-primary" />
								<rect x="19" y="1" width="2" height="2" rx="1" class="has-fill-secondary" />
							</svg>
						</span>
					</span>
					<span role="menuitem">
Light					</span>
				</button>
			</li>
			<li class="theme is-block">
				<button class="button is-text is-small theme-control is-fullwidth has-flex-justify-content-start"
					data-theme-to="dark">
					<span class="theme-dark has-margin-right-small">
						<span
							class="has-border theme-selector-icon css-variable-support is-inline-block has-body-background"
							aria-hidden="true">
							<svg class="svg" xmlns="http://www.w3.org/2000/svg"
								viewBox="0 0 22 14">
								<rect width="22" height="14" class="has-fill-body-background" />
								<rect x="5" y="5" width="12" height="4" class="has-fill-secondary" />
								<rect x="5" y="2" width="2" height="1" class="has-fill-secondary" />
								<rect x="8" y="2" width="2" height="1" class="has-fill-secondary" />
								<rect x="11" y="2" width="3" height="1" class="has-fill-secondary" />
								<rect x="1" y="1" width="2" height="2" class="has-fill-secondary" />
								<rect x="5" y="10" width="7" height="2" rx="0.3" class="has-fill-primary" />
								<rect x="19" y="1" width="2" height="2" rx="1" class="has-fill-secondary" />
							</svg>
						</span>
					</span>
					<span role="menuitem">
Dark					</span>
				</button>
			</li>
			<li class="theme is-block">
				<button class="button is-text is-small theme-control is-fullwidth has-flex-justify-content-start"
					data-theme-to="high-contrast">
					<span class="theme-high-contrast has-margin-right-small">
						<span
							class="has-border theme-selector-icon css-variable-support is-inline-block has-body-background"
							aria-hidden="true">
							<svg class="svg" xmlns="http://www.w3.org/2000/svg"
								viewBox="0 0 22 14">
								<rect width="22" height="14" class="has-fill-body-background" />
								<rect x="5" y="5" width="12" height="4" class="has-fill-secondary" />
								<rect x="5" y="2" width="2" height="1" class="has-fill-secondary" />
								<rect x="8" y="2" width="2" height="1" class="has-fill-secondary" />
								<rect x="11" y="2" width="3" height="1" class="has-fill-secondary" />
								<rect x="1" y="1" width="2" height="2" class="has-fill-secondary" />
								<rect x="5" y="10" width="7" height="2" rx="0.3" class="has-fill-primary" />
								<rect x="19" y="1" width="2" height="2" rx="1" class="has-fill-secondary" />
							</svg>
						</span>
					</span>
					<span role="menuitem">
High contrast					</span>
				</button>
			</li>
		</ul>
	</div>
</div>		</div>
	</div>
    <ul class="links" data-bi-name="footerlinks">
		<li><a data-mscc-ic="false" href="https://docs.microsoft.com/previous-versions/" data-bi-name="archivelink">Previous Version Docs</a></li>
		<li><a data-mscc-ic="false" href="https://docs.microsoft.com/teamblog" data-bi-name="bloglink">Blog</a></li>
		<li><a data-mscc-ic="false" href="https://docs.microsoft.com/contribute" data-bi-name="contributorGuide">Contribute</a></li>
			<li><a data-mscc-ic="false" href="https://go.microsoft.com/fwlink/?LinkId=521839" data-bi-name="privacy">Privacy &amp; Cookies</a></li>
		<li><a data-mscc-ic="false" href="/en-us/legal/termsofuse" data-bi-name="termsofuse">Terms of Use</a></li>
		<li><a data-mscc-ic="false" href="https://aka.ms/sitefeedback" data-bi-name="feedback">Site Feedback</a></li>
		<li><a data-mscc-ic="false" href="https://www.microsoft.com/en-us/legal/intellectualproperty/Trademarks/EN-US.aspx" data-bi-name="trademarks">Trademarks</a></li>
		<li>&copy; Microsoft 2020</li>
    </ul>
</footer>
	</div>

	<div id="action-panel" role="region" aria-label="Action Panel" class="action-panel has-default-focus" tabindex="-1"></div>
</body>
</html>
